#include <stdio.h>
#include <stdlib.h>
#include "jewels.h"

static int rounds;
static int map[8][8];

struct seq {
	int x1;
	int y1;
	int x2;
	int y2;
	int points;
};

void load_input(char *filename, int *rounds, int (*map)[8][8])
{
	FILE *file = fopen(filename, "r");
	if (file == NULL) {
		printf("Soubor %s nelze otevrit!\n", filename);
		exit(1);
	}

	fscanf(file, "%d", rounds);
	for (int i = 0; i < 8; i++)
		for (int j = 0; j < 8; j++)
			fscanf(file, "%1d", &(*map)[i][j]);
	fclose(file);
}

void print_emmap(struct seq seq)
{
	printf("\nRound %d\n", rounds);
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++)
			if ((i == seq.x1 || i == seq.x2)
			&& (j == seq.y1 || j == seq.y2))
				printf("\033[1;32m%d\033[0m ", map[i][j]);
			else
				printf("%d ", map[i][j]);
		putchar('\n');
	}
}

void output(struct seq seq)
{
	FILE *file = fopen("vystup.txt", "w");
	//print_emmap(seq);
	fprintf(file, "%d %d %d %d", seq.y1+1, seq.x1+1, seq.y2+1, seq.x2+1);
	fclose(file);
}

/* Najdi libovolny sled */
struct seq any_seq(int nth)
{
	struct seq seq;
	seq.points = -1;	/* Invalid value */

	/* Horizontal */
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 7; j++) {
			int points = valid_move(&map, i, j, i, j+1);
			if (points && nth-- <= 1)
				return (struct seq){i, j, i, j+1, points};
		}
	}


	/* Vertical */
	for (int i = 0; i < 7; i++) {
		for (int j = 0; j < 8; j++) {
			int points = valid_move(&map, i, j, i+1, j);
			if (points && nth-- <= 1)
				return (struct seq){i, j, i+1, j, points};
		}
	}

	return seq;
}

struct seq optimal_seq(void)
{
	return any_seq(1);
}

int main(void)
{
	load_input("vstup.txt", &rounds, &map);
	output(optimal_seq());
	return 0;
}