#include <stdio.h>
#include <stdlib.h>

void print_map(int (*map)[8][8])
{
	putchar('\n');
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++)
			printf("%d ", (*map)[i][j]);
		putchar('\n');
	}
}

void swap(int (*map)[8][8], int x1, int y1, int x2, int y2)
{
	int tmp = (*map)[x1][y1];
	(*map)[x1][y1] = (*map)[x2][y2];
	(*map)[x2][y2] = tmp;
}

int has_seq(int (*map)[8][8])
{
	int points = 0;

	/* Horizontal */
	for (int i = 0; i < 8; i++)
		for (int j = 0; j < 5; j++)
			if ((*map)[i][j] == (*map)[i][j+1] && (*map)[i][j] == (*map)[i][j+2])
				points++;

	/* Vertical */
	for (int i = 0; i < 5; i++)
		for (int j = 0; j < 8; j++)
			if ((*map)[i][j] == (*map)[i+1][j] && (*map)[i][j] == (*map)[i+2][j])
				points++;
	return points;
}

int valid_move(int (*map)[8][8], int x1, int y1, int x2, int y2)
{
	swap(map, x1, y1, x2, y2);
	int rv = has_seq(map);
	swap(map, x1, y1, x2, y2);
	return rv;
}