#include <stdlib.h>
#include "queue.h"

struct queue_item {
	void *value;
	struct queue_item *next;
	struct queue_item *prev;
};

void queue_init(queue_t *q)
{
	q->size = 0;
	q->first = NULL;
	q->last = NULL;
}

void queue_push(queue_t *q, void *value)
{
	struct queue_item *item;

	item = calloc(1, sizeof(struct queue_item));
	item->value = value;
	q->size++;

	if (q->first) {
		item->next = q->first;
		q->first->prev = item;
	} else {
		q->last = item;
	}
	q->first = item;
}

size_t queue_size(queue_t *q)
{
	return q->size;
}

void *queue_pop(queue_t *q)
{
	struct queue_item *victim = q->last;
	void *value = victim->value;

	q->last = victim->prev;
	if (q->last)
		q->last->next = NULL;
	else
		q->first = NULL;

	q->size--;
	free(victim);

	return value;
}